<?php
class Banner
{
	public $id;
	public $ordem;
	public $legenda;
	public $descricao;
	public $ativo = "S";
	public $path;
	public $url;
}

class BannerDAO implements DAOInterface
{
	private $_crud;

	function __construct($_crud = null)
	{
		$this->_crud = $_crud;

	}

	private function GetDefaultSelectSQL()
	{
		$sql = "SELECT
		B.id,
		B.legenda,
		B.descricao,
		B.path,  
		B.ordem,
		B.url, 
		B.ativo
		FROM banners B ";

		return $sql;
	}

	private function Select($selectSQL)
	{
		if($this->_crud)
		{
			$result = $this->_crud->GetRecords($selectSQL);
				
			if($result->success)
			{
				$values = $result->value;
				$objects = array();
				foreach($values as $dados)
				{
					unset($obj);
					$obj = new Banner;
					$obj->id = $dados["id"];
					$obj->ordem = $dados["ordem"];
					$obj->path = $dados["path"];
					$obj->descricao = $dados["descricao"];
					$obj->legenda = $dados["legenda"];
					$obj->url = $dados["url"];
					$obj->ativo = $dados["ativo"];
					$objects[] = $obj;
				}

				return new ReturnStruct(true, $objects, $result->message);
			}
			else
			{
				return new ReturnStruct(false, null, $result->message);
			}
		}
		else
		{
			throw new Exception("CRUD no definido!");
		}
	}

	public function Find($where = "", $orderBy = "B.legenda", $limit = "")
	{
		$selectSQL = $this->GetDefaultSelectSQL();
		if($where!="")
		{
			$selectSQL .= " WHERE ".$where;
		}

		$selectSQL .= " ORDER BY ".$orderBy;

		if($limit!="")
		{
			$selectSQL .= " LIMIT ".$limit;
		}

		return $this->Select($selectSQL);
	}
	
	public function FindByKey($fields)
	{
		$selectSQL = $this->GetDefaultSelectSQL();

		if(count($fields) > 0)
		{
			$selectSQL .= " WHERE ";
			foreach($fields as $field)
			{
				$selectSQL .= " (".$field["name"]." = '".$field["value"]."') AND";
			}
		}

		$selectSQL = substr($selectSQL, 0, strlen($selectSQL)-4);

		//echo $selectSQL;

		$result = $this->Select($selectSQL);

		if($result->success)
		{
			$value = $result->value;

			if(count($value) > 0)
			{
				return $value[0];
			}
			else
			{
				throw new Exception("Banner no encontrado!");
			}
		}
		else
		{
			throw new Exception($result->message);
		}
	}

	public function CountNumRows($where = "")
	{
		$selectSQL = "SELECT COUNT(*) FROM banners B";

		if($where!="")
		{
			$selectSQL .= " WHERE ".$where;
		}

		//echo $selectSQL;

		$res = $this->_crud->ExecuteScalar($selectSQL);
		if($res->success)
		{
			return $res->value;
		}
		else
		{
			throw new Exception('Erro ao selecionar total de registros! Erro: '.$res->message);
		}
	}

	public function Insert($object)
	{
		$sql = "INSERT INTO banners ".
				"(ordem, legenda, descricao, path, url, ativo) ".
				"values ( ".				
				"'".$object->ordem."', ".
				"'".$object->legenda."', ".
				"'".$object->descricao."', ".
				"'".$object->path."', ".
				"'".$object->url."', ".
				"'".$object->ativo."')";

		$result = $this->_crud->ExecutaSQL($sql, true);

		if($result->success)
		{
			$object->id = $result->message->GetMessage();
			return new ReturnStruct(true, $object, "Registro inserido com sucesso!");
		}
		else
		{
			return $result;
		}

	}

	public function Update($object)
	{
		$sql = "UPDATE banners SET ".
				"legenda = '".$object->legenda."', ".
				"descricao = '".$object->descricao."', ".
				"ordem = '".$object->ordem."', ".				
				"url = '".$object->url."', ".
				"ativo = '".$object->ativo."' ".
				"WHERE ".
				"id = ".$object->id;

		$result = $this->_crud->ExecutaSQL($sql);

		if($result->success)
		{
			return new ReturnStruct(true, $object, "Registro alterado com sucesso!");
		}
		else
		{
			return $result;
		}

	}
	
	public function Delete($object)
	{
		$sql = "DELETE FROM banners WHERE id = ".$object->id;

		$result = $this->_crud->ExecutaSQL($sql);

		if($result->success)
		{
			return new ReturnStruct(true, null, "Registro removido com sucesso!");
		}
		else
		{
			return $result;
		}

	}

}